#ifndef APPLICATION_ACCESS_H_
#define APPLICATION_ACCESS_H_

#include <QObject>
#include <QList>
#include <QVariant>

#include "currency.hpp"

namespace kdk
{
namespace kabase
{

class ApplicationAccess
{
public:
    ApplicationAccess();
    ~ApplicationAccess();

    /**
     * @brief 导出函数
     *
     * @param appname 应用名
     * @param object 要导出函数的对象指针
     *
     * @retval true 成功
     * @retval false 失败
     */
    bool exportFunc(AppName appName, QObject *object);

    /**
     * @brief 调用函数
     *
     * @param appName 应用名
     * @param methodName 函数名
     * @param args 函数参数列表
     *
     * @return 函数返回结果
     */
    QList<QVariant> callMethod(AppName appName, QString methodName, QList<QVariant> args = QList<QVariant>());

private:
    QString getServiceName(AppName appName);
    QString getObjectPath(AppName appName);
    QString getInterfaceName(AppName AppName);
};

} /* namespace kabase */
} /* namespace kdk */

#endif